-- ---------------------------------------------------------------------------------------------------------------------------------
---
--		Thanks to the authors of:
--
--		Yata:
--		To study the code of Yata helped me a lot to realize this mod.
--
--		Numen:
--		Without Numen I would not have ever made the rework and improvments of Klappa.
--
--		Bartender3:
--		Helped me a lot with the actionbutton stuff.
--
-- --------------------------------------------------------------------------------------------------------------------------------

Klappa = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceConsole-2.0", "AceDebug-2.0");
local L = AceLibrary("AceLocale-2.2"):new("Klappa")

local _G = getfenv(0)

-- Fubar-Options
Klappa.name = "Klappa";
Klappa.hasIcon = "Interface\\Icons\\INV_Weapon_ShortBlade_17";
Klappa.hasNoColor = true;
Klappa.defaultMinimapPosition = 200;
Klappa.clickableTooltip  = false;
Klappa.independentProfile = true;
Klappa.defaultPosition = "RIGHT";
Klappa.hideWithoutStandby = true;
Klappa.cannotDetachTooltip = true;


local defaults = 
{
	bars = {
		{
			buttons = {
				{
					id = 1,
					popups = 
					{
					},
				},
			},
		},
	},
	defaults = 
		{
			numberButtons = 1,
			numberBars = 1,
			orient = "vertleft",
			buttonScale = 1,
			popupScale = 1,
			alpha = 1,
			popupAlpha = 1,
			locked = true,
			lockButtons = true,
			padding = 1,
			size = 35,
			tooltip = true,
			id = 20,
			debugging = false;
		}
}

function Klappa:InitOptions()
	local options = {
		type="group",   
		args = { 
			add = {
				name = L["Add Bar"],
				desc = L["Add a new bar"],
				type = "execute",
				order = 1,
				func = function() self:AddBar() end,
			},
			del = {
				name = L["Delete Bar"],
				desc = L["Delete the last bar"],
				type = "execute",
				order = 2,
				func = function() self:DeleteBar() end,
			},
		}
	}

	return options;
end

function Klappa:OnInitialize()
	
	Klappa:RegisterDB("KlappaDB");
	Klappa:RegisterDefaults("profile", defaults);
	
	Klappa.config = self.db.profile;
	self.options = self:InitOptions();
	self.OnMenuRequest = self.options;
	self:RegisterChatCommand("/klappa", self.options);
end

function Klappa:OnEnable()
	self:SetDebugging(Klappa.config.defaults.debugging);
	self:CreateRoot();
end

function Klappa:OnProfileDisable() 
	Klappa:Debug("Disable profile");
	-- for i, button in pairs (self.root.buttons) do
		-- button.button:Hide();
		-- button:UnregisterGeneralEvents();
		-- button:UnregisterButtonEvents();
		-- button.header = nil;
		-- button.button.normalTexture:ClearAllPoints();
		-- button.button.normalTexture = nil;
		-- for i, popup in pairs(button.popupButtons) do
			-- popup.button.icon:Hide();
			-- popup:UnregisterGeneralEvents();
			-- popup:UnregisterButtonEvents();
			-- popup.button:SetAttribute("showstates", "!*");
			-- popup.button:Hide();
			-- popup.button = nil;
			-- popup = nil;
		-- end
		-- button.button.popups = nil;
		-- button.button = nil;
		-- button = nil;
		--Klappa.config[1].buttons[i] = nil;
		-- Klappa.options.args["Main"..i] = nil;
		--Klappa.config[1].numberButtons = index-1;
	-- end
	-- self.root = nil;
end

function Klappa:OnProfileEnable()
	--Klappa.config = Klappa.db.profile;
	--self:CreateRoot();
end

function Klappa:OnDisable()

end

function Klappa:CreateRoot()
	self.bars = {};
	
	for i, bar in pairs (Klappa.config.bars) do
		--if(bar == Klappa.config.defaults or bar ==Klappa.config["detachedTooltip"]) then break end
		self.bars[i] = Klappa.Bar:new(i);
	end
	self:HideEmpty();
end

function Klappa:AddBar()
	idx = Klappa.config.defaults.numberBars + 1;
	Klappa.config.bars[idx] = {};
	Klappa.config.bars[idx].id = 20;
	self.bars[idx] = Klappa.Bar:new(idx);
	Klappa.config.defaults.numberBars = idx;
	Klappa:ReloadCyCircled();
end

function Klappa:DeleteBar()
	local idx = Klappa.config.defaults.numberBars;
	if (idx == 0 or idx == nil) then return end;
	self.bars[idx].root:Hide();
	for i, mainbutton in pairs (self.bars[idx].root.buttons) do
		self.bars[idx]:DelMainButton();
	end
	--self.bars[idx].root = nil;
	
	Klappa.config.bars[idx] = nil;
	Klappa.options.args["Bar"..idx] = nil;
	Klappa.config.defaults.numberBars = idx-1;
end

function Klappa:ReloadCyCircled()
	if IsAddOnLoaded("cyCircled") then
		local cydb = cyCircled:AcquireDBNamespace("Klappa");
		if(cydb) then
			if(cydb.profile["Main"] or cydb.profile["Popup"]) then
				cyCircled_Klappa.elements = {};
				cyCircled_Klappa:SetupElements();
				cyCircled_Klappa:ApplySkin();
				cyCircled_Klappa:ApplyColors();
				Klappa:Debug("Applied cyCircled skin");
			end
		end
	end
	self:HideEmpty();
end

function Klappa:HideEmpty()
	for k, bar in pairs(Klappa.bars) do
		for i, main in pairs(bar.root.buttons) do
			local texture = GetActionTexture(main.button.id);
			if(texture) then
				for k2,popup in pairs(bar.root.buttons[i].popupButtons) do
					local popuptexture = GetActionTexture(popup.button.id);
					if not(popuptexture) then
						popup.button:Hide();
					end
				end
			else
				main.button:Hide();
			end
		end
	end
end

